# FILE:
#   symbols.s
#
# PURPOSE:
#   Define VM callback symbols for Mips2cs/Coercri
#
# AUTHOR:
#   Stephen Thompson <stephen@solarflare.org.uk>
#
# CREATED:
#   19-Jun-2011
#
# COPYRIGHT:
#   Copyright (C) Stephen Thompson, 2011.
#
#   This file is part of Mips2cs. Mips2cs is distributed under the terms
#   of the Boost Software License, Version 1.0, the text of which
#   appears below.
#
#   Boost Software License - Version 1.0 - August 17th, 2003
#   
#   Permission is hereby granted, free of charge, to any person or organization
#   obtaining a copy of the software and accompanying documentation covered by
#   this license (the "Software") to use, reproduce, display, distribute,
#   execute, and transmit the Software, and to prepare derivative works of the
#   Software, and to permit third-parties to whom the Software is furnished to
#   do so, all subject to the following:
#
#   The copyright notices in the Software and this entire statement, including
#   the above license grant, this restriction and the following disclaimer,
#   must be included in all copies of the Software, in whole or in part, and
#   all derivative works of the Software, unless such copies or derivative
#   works are solely in the form of machine-executable object code generated by
#   a source language processor.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
#   SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
#   FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
#   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.


# Symbols defined by Mips2cs
        
        .set    _exit, 0
        .global _exit

        .set    vm_yield, 4
        .global vm_yield

        .set    sbrk, 8
        .global sbrk

	.set	vm_write, 0x10
	.global	vm_write

        .set    vm_read, 0x14
        .global vm_read

# Callback routines defined in CoercriCallbacks.cs
        
        .set    vm_get_num_full_screen_modes, 0x20
        .global vm_get_num_full_screen_modes

        .set    vm_get_full_screen_modes, 0x24
        .global vm_get_full_screen_modes

        .set    vm_get_desktop_mode, 0x28
        .global vm_get_desktop_mode

        .set    vm_create_window, 0x2c
        .global vm_create_window

        .set    vm_switch_window, 0x30
        .global vm_switch_window

        .set    vm_is_full_screen, 0x34
        .global vm_is_full_screen

        .set    vm_create_graphic, 0x38
        .global vm_create_graphic

        .set    vm_destroy_graphic, 0x3c
        .global vm_destroy_graphic

        .set    vm_get_window_size, 0x40
        .global vm_get_window_size

        .set    vm_set_clip_rectangle, 0x44
        .global vm_set_clip_rectangle

        .set    vm_clear_clip_rectangle, 0x48
        .global vm_clear_clip_rectangle

        .set    vm_get_clip_rectangle, 0x4c
        .global vm_get_clip_rectangle

        .set    vm_clear_screen, 0x50
        .global vm_clear_screen

        .set    vm_plot_pixel, 0x54
        .global vm_plot_pixel

        .set    vm_draw_line, 0x58
        .global vm_draw_line

        .set    vm_fill_rectangle, 0x5c
        .global vm_fill_rectangle

        .set    vm_draw_graphic, 0x60
        .global vm_draw_graphic

        .set    vm_get_graphic_width, 0x64
        .global vm_get_graphic_width

        .set    vm_get_graphic_height, 0x68
        .global vm_get_graphic_height

        .set    vm_get_graphic_handle, 0x6c
        .global vm_get_graphic_handle

        .set    vm_get_graphic_pixels, 0x70
        .global vm_get_graphic_pixels

        .set    vm_end_batches, 0x74
        .global vm_end_batches

	.set	vm_get_msec, 0x78
	.global vm_get_msec

	.set 	vm_sleep, 0x7c
	.global vm_sleep

	.set	vm_get_mouse_pos, 0x80
	.global	vm_get_mouse_pos
