# FILE:
#   reloc.s
#
# PURPOSE:	
#   Test that indirect jump targets are being inferred correctly
#   from the relocation information.
#
# AUTHOR:
#   Stephen Thompson <stephen@solarflare.org.uk>
#
# CREATED:
#   12-Jun-2011
#
# COPYRIGHT:
#   Copyright (C) Stephen Thompson, 2011.
#
#   This file is part of Mips2cs. Mips2cs is distributed under the terms
#   of the Boost Software License, Version 1.0, the text of which
#   appears below.
#
#   Boost Software License - Version 1.0 - August 17th, 2003
#   
#   Permission is hereby granted, free of charge, to any person or organization
#   obtaining a copy of the software and accompanying documentation covered by
#   this license (the "Software") to use, reproduce, display, distribute,
#   execute, and transmit the Software, and to prepare derivative works of the
#   Software, and to permit third-parties to whom the Software is furnished to
#   do so, all subject to the following:
#
#   The copyright notices in the Software and this entire statement, including
#   the above license grant, this restriction and the following disclaimer,
#   must be included in all copies of the Software, in whole or in part, and
#   all derivative works of the Software, unless such copies or derivative
#   works are solely in the form of machine-executable object code generated by
#   a source language processor.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
#   SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
#   FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
#   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.


	.set noat
	.text

dummy:
	nop
	nop
	j	0
		
test_la:
	move	$s0, $ra
	la	$a0, msg1
	li	$a1, 14
	jal	16
	jr	$s0

test_indirect:
	move	$s0, $ra
	la	$a0, msg2
	li	$a1, 14
	jal	16
	jr	$s0

test_gprel:
	move	$s0, $ra
	la	$a0, msg3
	li	$a1, 14
	jal	16
	jr	$s0

test_direct:
	move	$s0, $ra
	la	$a0, msg4
	li	$a1, 14
	jal	16
	jr	$s0
	
_start:
.global _start
	la	$gp, _gp		# Needed for gp-relative addressing to work
	
	la	$t0, test_la		# Tests R_MIPS_HI16, R_MIPS_LO16
	jalr	$t0

	la	$t0, test_indirect_addr
	lw	$t0, ($t0)		# Tests R_MIPS_32
	jalr	$t0

	lw	$t0, test_gprel_addr	# Tests R_MIPS_GPREL16 and R_MIPS_32
	jalr	$t0

	jal	test_direct		# Tests R_MIPS_26
	
	j	0			# Exit.


	.sdata
test_gprel_addr:	.word	test_gprel
	
	.data
test_indirect_addr:	.word	test_indirect
msg1:	.ascii "test 1 passed\n"
msg2:	.ascii "test 2 passed\n"
msg3:	.ascii "test 3 passed\n"
msg4:	.ascii "test 4 passed\n"
